#ifndef _BBUART_H_
#define _BBUART_H_

#include <PalmOS.h>

struct Uart68K;
struct Gpio68K;

enum UartOption {
	Uart328,
	UartEZ,
	UartNumberOne,	//VZ/SZ
	UartNumberTwo,	//VZ/SZ
	UartUnknown,
};

struct UartState {
	struct Uart68K *uart;
	struct Gpio68K *gpio;
	UInt8 txBit, rxBit;			//bit shift
	UInt16 serLibRef;
};

Boolean bbUartOpen(struct UartState *state, enum UartOption uo);
void bbUartClose(struct UartState *state);
enum UartOption portPrvFind(void);

//return num bytes RXed
UInt16 bbUArtTxThenRx(struct UartState *state, Int16 tx, void *dst, UInt16 maxBytes, UInt32 maxWait);




#endif

